Index: src/Actions/TesselationAction/NonConvexEnvelopeAction.hpp
===================================================================
--- src/Actions/TesselationAction/NonConvexEnvelopeAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/TesselationAction/NonConvexEnvelopeAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,31 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
 
-class TesselationListClass;
-
-void TesselationNonConvexEnvelope(double radius, std::string &filename);
-
-class TesselationNonConvexEnvelopeAction : public Action {
-  friend void TesselationNonConvexEnvelope(double radius, std::string &filename);
-
-public:
-  TesselationNonConvexEnvelopeAction();
-  virtual ~TesselationNonConvexEnvelopeAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
-
+#include "NonConvexEnvelopeAction.def"
+#include "Action_impl_header.hpp"
 
 #endif // NONCONVEXENVELOPEACTION_HPP
Index: src/Actions/ValueStorage.cpp
===================================================================
--- src/Actions/ValueStorage.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/ValueStorage.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * ValueStorage.cpp
@@ -6,9 +13,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
 
 #include "ValueStorage.hpp"
 #include "Patterns/Singleton_impl.hpp"
 
-ValueStorage::ValueStorage() {};
+ValueStorage::ValueStorage() :
+  MapOfActions_instance(MapOfActions::getInstance())
+{};
 
 ValueStorage::~ValueStorage() {};
Index: src/Actions/ValueStorage.hpp
===================================================================
--- src/Actions/ValueStorage.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/ValueStorage.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -8,5 +8,4 @@
 #ifndef VALUESTORAGE_HPP_
 #define VALUESTORAGE_HPP_
-
 
 #include "Actions/MapOfActions.hpp"
@@ -22,11 +21,31 @@
 
 public:
-  template <typename T> void queryCurrentValue(const char *name, T &_T) {
-    MapOfActions::getInstance().queryCurrentValue(name, _T);
-  }
-  template <typename T> void setCurrentValue(const char *name, T &_T) {
-    MapOfActions::getInstance().setCurrentValue(name, _T);
+  /** Gets a value from the storage
+   * If the value is not present, an ASSERT is thrown unless optional is set to true.
+   * \param _T key of value
+   * \param optional whether this value is optional, i.e. may actually not be in the storage (i.e. may return false in this case).
+   * \return true - value present, false - value not present (only given when optional set to true)
+   */
+  template <typename T> bool queryCurrentValue(const char *name, T &_T, const bool optional = false) {
+    if (optional) {
+      if (!MapOfActions_instance.isCurrentValuePresent(name))
+        return false;
+    }
+    MapOfActions_instance.queryCurrentValue(name, _T);
+    return true;
   }
 
+  /** Sets a value in the storage.
+   * \param name key of value
+   * \param _T value
+   */
+  template <typename T> void setCurrentValue(const char *name, T &_T) {
+    MapOfActions_instance.setCurrentValue(name, _T);
+  }
+
+  /** Obtain a descriptive text for a given key.
+   * \param actionname key
+   * \return text describing the key's contents
+   */
   std::string getDescription(std::string actionname);
 
@@ -34,4 +53,6 @@
   ValueStorage();
   ~ValueStorage();
+
+  MapOfActions &MapOfActions_instance;
 };
 
Index: src/Actions/WorldAction/AddEmptyBoundaryAction.cpp
===================================================================
--- src/Actions/WorldAction/AddEmptyBoundaryAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/AddEmptyBoundaryAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * AddEmptyBoundaryAction.cpp
@@ -6,11 +13,14 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/WorldAction/AddEmptyBoundaryAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
-#include "log.hpp"
-#include "vector.hpp"
+#include "Helpers/Log.hpp"
+#include "LinearAlgebra/Vector.hpp"
 #include "World.hpp"
 
@@ -21,38 +31,17 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
-#include "Helpers/Assert.hpp"
+#include "Actions/WorldAction/AddEmptyBoundaryAction.hpp"
 
-const char WorldAddEmptyBoundaryAction::NAME[] = "boundary";
-
-WorldAddEmptyBoundaryAction::WorldAddEmptyBoundaryAction() :
-  Action(NAME)
-{}
-
-WorldAddEmptyBoundaryAction::~WorldAddEmptyBoundaryAction()
-{}
-
-void WorldAddEmptyBoundary(Vector &boundary) {
-  ValueStorage::getInstance().setCurrentValue(WorldAddEmptyBoundaryAction::NAME, boundary);
-  ActionRegistry::getInstance().getActionByName(WorldAddEmptyBoundaryAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* WorldAddEmptyBoundaryAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryVector(NAME, false, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "AddEmptyBoundaryAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr WorldAddEmptyBoundaryAction::performCall() {
-  Vector boundary;
   Vector Min;
   Vector Max;
   int j=0;
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, boundary);
+  // obtain information
+  getParametersfromValueStorage();
 
   // get maximum and minimum
@@ -60,12 +49,12 @@
   ASSERT(AllAtoms.size() > 0, "There must be atoms present for AddingEmptyBoundary.");
   vector<atom *>::iterator AtomRunner = AllAtoms.begin();
-  Min = (*AtomRunner)->x;
-  Max = (*AtomRunner)->x;
+  Min = (*AtomRunner)->getPosition();
+  Max = (*AtomRunner)->getPosition();
   for (; AtomRunner != AllAtoms.end(); ++AtomRunner) {
     for (int i=0;i<NDIM;i++) {
-      if ((*AtomRunner)->x[i] > Max[i])
-        Max[i] = (*AtomRunner)->x[i];
-      if ((*AtomRunner)->x[i] < Min[i])
-        Min[i] = (*AtomRunner)->x[i];
+      if ((*AtomRunner)->at(i) > Max[i])
+        Max[i] = (*AtomRunner)->at(i);
+      if ((*AtomRunner)->at(i) < Min[i])
+        Min[i] = (*AtomRunner)->at(i);
     }
   }
@@ -77,5 +66,5 @@
   for (int i=0;i<NDIM;i++) {
     j += i+1;
-    cell_size[j] = (Max[i]-Min[i]+2.*boundary[i]);
+    cell_size[j] = (Max[i]-Min[i]+2.*params.boundary[i]);
   }
   World::getInstance().setDomain(cell_size);
@@ -84,5 +73,5 @@
   AtomRunner = AllAtoms.begin();
   for (; AtomRunner != AllAtoms.end(); ++AtomRunner)
-    (*AtomRunner)->x -= Min - boundary;
+    *(*AtomRunner) -= Min - params.boundary;
   return Action::success;
 }
@@ -113,2 +102,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/WorldAction/AddEmptyBoundaryAction.def
===================================================================
--- src/Actions/WorldAction/AddEmptyBoundaryAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/WorldAction/AddEmptyBoundaryAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * AddEmptyBoundaryAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "LinearAlgebra/Vector.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (Vector)
+#define paramtokens (WorldAddEmptyBoundaryAction::NAME)
+#define paramreferences (boundary)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY World
+#define ACTIONNAME AddEmptyBoundary
+#define TOKEN "boundary"
+
Index: src/Actions/WorldAction/AddEmptyBoundaryAction.hpp
===================================================================
--- src/Actions/WorldAction/AddEmptyBoundaryAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/AddEmptyBoundaryAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,28 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include "vector.hpp"
 
-void WorldAddEmptyBoundary(Vector &boundary);
-
-class WorldAddEmptyBoundaryAction : public Action {
-  friend void WorldAddEmptyBoundary(Vector &boundary);
-
-public:
-  WorldAddEmptyBoundaryAction();
-  virtual ~WorldAddEmptyBoundaryAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "AddEmptyBoundaryAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* ADDEMPTYBOUNDARYACTION_HPP_ */
Index: src/Actions/WorldAction/BoundInBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/BoundInBoxAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/BoundInBoxAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * BoundInBoxAction.cpp
@@ -6,9 +13,12 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/WorldAction/BoundInBoxAction.hpp"
-#include "Actions/ActionRegistry.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 #include "World.hpp"
@@ -20,30 +30,13 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/WorldAction/BoundInBoxAction.hpp"
 
-const char WorldBoundInBoxAction::NAME[] = "bound-in-box";
-
-WorldBoundInBoxAction::WorldBoundInBoxAction() :
-  Action(NAME)
-{}
-
-WorldBoundInBoxAction::~WorldBoundInBoxAction()
-{}
-
-void WorldBoundInBox() {
-  ActionRegistry::getInstance().getActionByName(WorldBoundInBoxAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* WorldBoundInBoxAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "BoundInBoxAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr WorldBoundInBoxAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
   // center
@@ -80,2 +73,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/WorldAction/BoundInBoxAction.def
===================================================================
--- src/Actions/WorldAction/BoundInBoxAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/WorldAction/BoundInBoxAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * BoundInBoxAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY World
+#define ACTIONNAME BoundInBox
+#define TOKEN "bound-in-box"
+
Index: src/Actions/WorldAction/BoundInBoxAction.hpp
===================================================================
--- src/Actions/WorldAction/BoundInBoxAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/BoundInBoxAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -11,26 +11,6 @@
 #include "Actions/Action.hpp"
 
-void WorldBoundInBox();
-
-class WorldBoundInBoxAction : public Action {
-  friend void WorldBoundInBox();
-
-public:
-  WorldBoundInBoxAction();
-  virtual ~WorldBoundInBoxAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "BoundInBoxAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* BOUNDINBOXACTION_HPP_ */
Index: src/Actions/WorldAction/CenterInBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/CenterInBoxAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/CenterInBoxAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * CenterInBoxAction.cpp
@@ -6,10 +13,13 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/WorldAction/CenterInBoxAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Box.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 #include "World.hpp"
@@ -20,35 +30,15 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/WorldAction/CenterInBoxAction.hpp"
 
-const char WorldCenterInBoxAction::NAME[] = "center-in-box";
+// and construct the stuff
+#include "CenterInBoxAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr WorldCenterInBoxAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
-WorldCenterInBoxAction::WorldCenterInBoxAction() :
-  Action(NAME)
-{}
-
-WorldCenterInBoxAction::~WorldCenterInBoxAction()
-{}
-
-void WorldCenterInBox(Box &_box) {
-  ValueStorage::getInstance().setCurrentValue(WorldCenterInBoxAction::NAME, _box);
-  ActionRegistry::getInstance().getActionByName(WorldCenterInBoxAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* WorldCenterInBoxAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryBox(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr WorldCenterInBoxAction::performCall() {
-
-  Box& cell_size = World::getInstance().getDomain();
-  ValueStorage::getInstance().queryCurrentValue(NAME, cell_size);
-  World::getInstance().setDomain(cell_size.getM());
+  World::getInstance().setDomain(params.cell_size.getM());
 
   // center
@@ -85,2 +75,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/WorldAction/CenterInBoxAction.def
===================================================================
--- src/Actions/WorldAction/CenterInBoxAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/WorldAction/CenterInBoxAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * CenterInBoxAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "Box.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (Box)
+#define paramtokens (WorldCenterInBoxAction::NAME)
+#define paramreferences (cell_size)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY World
+#define ACTIONNAME CenterInBox
+#define TOKEN "center-in-box"
+
Index: src/Actions/WorldAction/CenterInBoxAction.hpp
===================================================================
--- src/Actions/WorldAction/CenterInBoxAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/CenterInBoxAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,28 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include "Box.hpp"
 
-void WorldCenterInBox(Box &_box);
-
-class WorldCenterInBoxAction : public Action {
-  friend void WorldCenterInBox(Box &_box);
-
-public:
-  WorldCenterInBoxAction();
-  virtual ~WorldCenterInBoxAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "CenterInBoxAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* CENTERINBOXACTION_HPP_ */
Index: src/Actions/WorldAction/CenterOnEdgeAction.cpp
===================================================================
--- src/Actions/WorldAction/CenterOnEdgeAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/CenterOnEdgeAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * CenterOnEdgeAction.cpp
@@ -6,13 +13,16 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/WorldAction/CenterOnEdgeAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
-#include "log.hpp"
-#include "vector.hpp"
+#include "Helpers/Log.hpp"
+#include "LinearAlgebra/Vector.hpp"
 #include "World.hpp"
-#include "Matrix.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 
 #include <iostream>
@@ -21,33 +31,16 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
-#include "Helpers/Assert.hpp"
+#include "Actions/WorldAction/CenterOnEdgeAction.hpp"
 
-const char WorldCenterOnEdgeAction::NAME[] = "center-edge";
-
-WorldCenterOnEdgeAction::WorldCenterOnEdgeAction() :
-  Action(NAME)
-{}
-
-WorldCenterOnEdgeAction::~WorldCenterOnEdgeAction()
-{}
-
-void WorldCenterOnEdge() {
-  ActionRegistry::getInstance().getActionByName(WorldCenterOnEdgeAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* WorldCenterOnEdgeAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "CenterOnEdgeAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr WorldCenterOnEdgeAction::performCall() {
   Vector Min;
   Vector Max;
+
+  // obtain information
+  getParametersfromValueStorage();
 
   // get maximum and minimum
@@ -55,12 +48,12 @@
   ASSERT(AllAtoms.size() > 0, "For CenteronEdge atoms must be present.");
   vector<atom *>::iterator AtomRunner = AllAtoms.begin();
-  Min = (*AtomRunner)->x;
-  Max = (*AtomRunner)->x;
+  Min = (*AtomRunner)->getPosition();
+  Max = (*AtomRunner)->getPosition();
   for (; AtomRunner != AllAtoms.end(); ++AtomRunner) {
     for (int i=0;i<NDIM;i++) {
-      if ((*AtomRunner)->x[i] > Max[i])
-        Max[i] = (*AtomRunner)->x[i];
-      if ((*AtomRunner)->x[i] < Min[i])
-        Min[i] = (*AtomRunner)->x[i];
+      if ((*AtomRunner)->at(i) > Max[i])
+        Max[i] = (*AtomRunner)->at(i);
+      if ((*AtomRunner)->at(i) < Min[i])
+        Min[i] = (*AtomRunner)->at(i);
     }
   }
@@ -75,5 +68,5 @@
   // translate all atoms, such that Min is aty (0,0,0)
   for (vector<atom*>::iterator AtomRunner = AllAtoms.begin(); AtomRunner != AllAtoms.end(); ++AtomRunner)
-    (*AtomRunner)->x -= Min;
+    *(*AtomRunner) -= Min;
 
   return Action::success;
@@ -105,2 +98,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/WorldAction/CenterOnEdgeAction.def
===================================================================
--- src/Actions/WorldAction/CenterOnEdgeAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/WorldAction/CenterOnEdgeAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * CenterOnEdgeAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY World
+#define ACTIONNAME CenterOnEdge
+#define TOKEN "center-edge"
+
Index: src/Actions/WorldAction/CenterOnEdgeAction.hpp
===================================================================
--- src/Actions/WorldAction/CenterOnEdgeAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/CenterOnEdgeAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -11,26 +11,6 @@
 #include "Actions/Action.hpp"
 
-void WorldCenterOnEdge();
-
-class WorldCenterOnEdgeAction : public Action {
-  friend void WorldCenterOnEdge();
-
-public:
-  WorldCenterOnEdgeAction();
-  virtual ~WorldCenterOnEdgeAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "CenterOnEdgeAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* CENTERONEDGEACTION_HPP_ */
Index: src/Actions/WorldAction/ChangeBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/ChangeBoxAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/ChangeBoxAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * ChangeBoxAction.cpp
@@ -6,13 +13,16 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/WorldAction/ChangeBoxAction.hpp"
-#include "Actions/ActionRegistry.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 #include "Box.hpp"
-#include "Matrix.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 
 #include <iostream>
@@ -21,35 +31,15 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/WorldAction/ChangeBoxAction.hpp"
 
-const char WorldChangeBoxAction::NAME[] = "change-box";
+// and construct the stuff
+#include "ChangeBoxAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr WorldChangeBoxAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
-WorldChangeBoxAction::WorldChangeBoxAction() :
-  Action(NAME)
-{}
-
-WorldChangeBoxAction::~WorldChangeBoxAction()
-{}
-
-void WorldChangeBox(Box &_box) {
-  ValueStorage::getInstance().setCurrentValue(WorldChangeBoxAction::NAME, _box);
-  ActionRegistry::getInstance().getActionByName(WorldChangeBoxAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* WorldChangeBoxAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryBox(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr WorldChangeBoxAction::performCall() {
-
-  Box cell_size;
-  ValueStorage::getInstance().queryCurrentValue(NAME, cell_size);
-  World::getInstance().setDomain(cell_size.getM()); // this is needed as only this function is OBSERVEd.
+  World::getInstance().setDomain(params.cell_size.getM()); // this is needed as only this function is OBSERVEd.
 
   DoLog(0) && (Log() << Verbose(0) << "Setting box domain to " << World::getInstance().getDomain().getM() << endl);
@@ -82,2 +72,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/WorldAction/ChangeBoxAction.def
===================================================================
--- src/Actions/WorldAction/ChangeBoxAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/WorldAction/ChangeBoxAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * ChangeBoxAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "Box.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (Box)
+#define paramtokens (WorldChangeBoxAction::NAME)
+#define paramreferences (cell_size)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY World
+#define ACTIONNAME ChangeBox
+#define TOKEN "change-box"
+
Index: src/Actions/WorldAction/ChangeBoxAction.hpp
===================================================================
--- src/Actions/WorldAction/ChangeBoxAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/ChangeBoxAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,28 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include "Box.hpp"
 
-void WorldChangeBox(Box &_box);
-
-class WorldChangeBoxAction : public Action {
-  friend void WorldChangeBox(Box &_box);
-
-public:
-  WorldChangeBoxAction();
-  virtual ~WorldChangeBoxAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "ChangeBoxAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* CHANGEBOXACTION_HPP_ */
